var EXPORTED_SYMBOLS = ["qfn_openInSingleMode"];  

var qfn_openInSingleMode = {

	_url: "chrome://qfnotes/content/editor.xul",
	_wm: Components.classes["@mozilla.org/appshell/window-mediator;1"]
			.getService(Components.interfaces.nsIWindowMediator),
    _ww: Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
			.getService(Components.interfaces.nsIWindowWatcher),
			
	//Global variables
	browserWin: "",
	tabbrowser: "",
	currentTabURL: "",
	currentTab: "",
	currentIndex: 0,
	
	_windows: function (type, funTab, funWin) {	//type:"navigator:browser"
		var browserEnumerator = this._wm.getEnumerator(type);
		while (browserEnumerator.hasMoreElements()) {
			this.browserWin = browserEnumerator.getNext();
			if (type == "navigator:browser") {
				this.tabbrowser = this.browserWin.gBrowser;
				
				var numTabs = this.tabbrowser.browsers.length;
				for (var index = 0; index < numTabs; index++) {
					this.currentTab = this.tabbrowser.tabContainer.childNodes[index];
					this.currentTabURL = this.tabbrowser.getBrowserAtIndex(index).currentURI.spec;
					this.currentIndex = index;
					funTab.call (this);
				}
			}
			funWin.call (this);
		}
	},
	/**Close QFN*/
	closeQFN: function () {
		//Closing QFN in Tabs and Sidebars
		this._windows ("navigator:browser",
					   //Closing all QFNs in tabs
					   function () {
							if (this._url == this.currentTabURL) {
								this.tabbrowser.removeTab(this.currentTab);
							}
					   }, 
					   //Closing Sidebar!
					   function () {
							var sidebarWindow = this.browserWin.document.getElementById("sidebar").contentWindow;

							if (sidebarWindow.location.href == this._url)
								this.browserWin.toggleSidebar();
								
							var contentsplitter = this.browserWin.document.getElementById("quickfox-notes-contentsplitter");
							var contentbox = this.browserWin.document.getElementById("quickfox-notes-contentbox");
							var browser = this.browserWin.document.getElementById("quickfox-notes-browser");
							contentsplitter.setAttribute("collapsed", true);
							contentbox.setAttribute("collapsed", true);
							browser.setAttribute("src", "about:blank");
					   });
		//Closing QFN in Windows
		this._windows ("editor:qfn",
					   function () {  }, 
					   //Closing Sidebar!
					   function () { 
							this.browserWin.close()
					   });
	},
	openInWindow: function (argument) {
		//Closing QFN in Tabs and Sidebars
		this._windows ("navigator:browser",
					   //Closing all QFNs in tabs
					   function () {
							if (this._url == this.currentTabURL) {
								this.tabbrowser.removeTab(this.currentTab);
							}
					   }, 
					   //Closing Sidebar!
					   function () {
							var sidebarWindow = this.browserWin.document.getElementById("sidebar").contentWindow;

							if (sidebarWindow.location.href == this._url)
								this.browserWin.toggleSidebar();
								
							var contentsplitter = this.browserWin.document.getElementById("quickfox-notes-contentsplitter");
							var contentbox = this.browserWin.document.getElementById("quickfox-notes-contentbox");
							var browser = this.browserWin.document.getElementById("quickfox-notes-browser");
							contentsplitter.setAttribute("collapsed", true);
							contentbox.setAttribute("collapsed", true);
							browser.setAttribute("src", "about:blank");
					   });
		
		var recentWindow = this._wm.getMostRecentWindow("navigator:browser");
		var win;
		if (recentWindow) {
			//win = recentWindow.openDialog(this._url, 'QuickFox Notes', 'chrome,resizable=yes,minimizable=yes,all', (argument ? argument : null));
			
			win = recentWindow.open(this._url, 'QuickFox Notes', 'chrome,resizable=yes,minimizable=yes,all', (argument ? argument : null))
			win.focus();
		}
		else {
			var array = Components.classes["@mozilla.org/array;1"]
				.createInstance(Components.interfaces.nsIMutableArray);
			var variant = Components.classes["@mozilla.org/variant;1"]
				.createInstance(Components.interfaces.nsIWritableVariant);
			variant.setFromVariant((argument ? argument : ""));  //command type for idle
			array.appendElement(variant, false);

			win = this._ww.openWindow(null, this._url, "QuickFox Notes", "chrome,resizable=yes,minimizable=yes,all", array);
			win.focus();
		}
		return win;
	},
	openInTab: function () {
		//Closing QFN in Sidebars
		var isQFNinTab = false;
		this._windows ("navigator:browser",
					   //Closing all QFNs in tabs
					   function () {
							if (this._url == this.currentTabURL) {
								this.tabbrowser.selectedTab = this.currentTab;
								this.browserWin.focus();
								isQFNinTab = true;
							}
					   }, 
					   //Closing Sidebar!
					   function () {
							var sidebarWindow = this.browserWin.document.getElementById("sidebar").contentWindow;

							if (sidebarWindow.location.href == this._url)
								this.browserWin.toggleSidebar();
								
							var contentsplitter = this.browserWin.document.getElementById("quickfox-notes-contentsplitter");
							var contentbox = this.browserWin.document.getElementById("quickfox-notes-contentbox");
							var browser = this.browserWin.document.getElementById("quickfox-notes-browser");
							contentsplitter.setAttribute("collapsed", true);
							contentbox.setAttribute("collapsed", true);
							browser.setAttribute("src", "about:blank");
					   });
		this._windows ("editor:qfn",
					   function () {  }, 
					   //Closing Sidebar!
					   function () { 
							this.browserWin.close()
					   });
					   
		if (!isQFNinTab) {
			var recentWindow = this._wm.getMostRecentWindow("navigator:browser");
			if (recentWindow) {
				recentWindow.delayedOpenTab(this._url, null, null, null, null);
			}
			else {
				this._ww.openWindow(null, this._url, "QuickFox Notes", "chrome", array);
			}
		}
	},
	openInSidebar: function (win) {
		//Closing QFN in Tabs
		this._windows ("navigator:browser",
					   //Closing all QFNs in tabs
					   function () {
							if (this._url == this.currentTabURL) {
								this.tabbrowser.removeTab(this.currentTab);
							}
					   }, 
					   //Detecting Sidebar!
					   function () {
							var sidebarWindow = this.browserWin.document.getElementById("sidebar").contentWindow;
							if (sidebarWindow.location.href == this._url) {
								this.browserWin.toggleSidebar();
								this.browserWin.document.getElementById("QuickFoxNotes-Sidebar-menuitem").setAttribute("checked", false);
							}
							
							var contentsplitter = this.browserWin.document.getElementById("quickfox-notes-contentsplitter");
							var contentbox = this.browserWin.document.getElementById("quickfox-notes-contentbox");
							var browser = this.browserWin.document.getElementById("quickfox-notes-browser");
							contentsplitter.setAttribute("collapsed", true);
							contentbox.setAttribute("collapsed", true);
							browser.setAttribute("src", "about:blank");
					   });
		this._windows ("editor:qfn",
					   function () {  }, 
					   //Closing Sidebar!
					   function () { 
							this.browserWin.close()
					   });

		win.document.getElementById("quickfox-notes-contentsplitter").setAttribute("collapsed", false);
		win.document.getElementById("quickfox-notes-contentbox").setAttribute("collapsed", false);
		var browser = win.document.getElementById("quickfox-notes-browser");
		var onloadListener = function() {
			if (browser.contentDocument.getElementById("editor.toolbar8.toolbarseparator")) {
				browser.contentDocument.getElementById("editor.toolbar8.toolbarseparator").setAttribute("collapsed", false);
				browser.contentDocument.getElementById("editor.toolbar8.toolbarbutton").setAttribute("collapsed", false);
			}
			browser.removeEventListener("DOMContentLoaded", onloadListener, false);
		}
		
		browser.addEventListener("DOMContentLoaded", onloadListener, false);
		browser.setAttribute("src", "chrome://qfnotes/content/editor.xul");
	}
}